<script setup lang="ts">
import { ref, reactive, onMounted, watch } from "vue";
import { useQuasar, type QTableProps } from "quasar";
import { useRouter } from "vue-router";

/** importStore*/
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";
import type { NewPagination } from "@/modules/14_KPI/interface/request/Main";
import type { DataOption } from "@/modules/14_KPI/interface/index/Main";

/** use*/
const $q = useQuasar();
const router = useRouter();
const { showLoader, hideLoader, dialogRemove, success } = useCounterMixin();

const positionOp = ref<DataOption[]>([]);
const positionMainOp = ref<DataOption[]>([]);

const maxPage = ref<number>(1);
const totalList = ref<number>(1); //จำนวนข้อมูลรายการ

/** หัวตาราง */
const rows = ref<any>([]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับตัวชี้วัด ",
    sortable: true,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "including",
    align: "left",
    label: "รหัสตัวชี้วัด",
    sortable: true,
    field: "including",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "includingName",
    align: "left",
    label: "ชื่อตัวชี้วัด",
    sortable: true,
    field: "includingName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);
const visibleColumns = ref<string[]>(["no", "including", "includingName"]);

const formFilter = reactive({
  page: 1,
  pageSize: 10,
  position: "",
  round: "",
  keyword: "",
  year: new Date().getFullYear(),
});
const pagination = ref({
  page: formFilter.page,
  rowsPerPage: formFilter.pageSize,
});

/** Option  รอบการประเมิน*/
const roundOp = ref<DataOption[]>([]);

function fetchList() {
  http
    .get(
      config.API.kpiRoleMainList +
        `?page=${formFilter.page}&pageSize=${formFilter.pageSize}&kpiPeriodId=${formFilter.round}&position=${formFilter.position}`
    )
    .then((res) => {
      const data = res.data.result.data;
      maxPage.value = Math.ceil(res.data.result.total / formFilter.pageSize);
      rows.value = data;
    })
    .finally(() => {
      hideLoader();
    });
}

function onClickAddOrView(status: boolean = false, id: string = "") {
  status
    ? router.push(`/KPI-indicator-role/${id}`)
    : router.push("/KPI-indicator-role/add");
}

function onClickDelete(id: number) {
  dialogRemove($q, () => {
    http
      .delete(config.API.kpiRoleMainList + `/${id}`)
      .then((res) => {
        success($q, "ลบข้อมูลสำเร็จ");
        fetchList();
      })
      .finally(() => {});
  });
}

function updatePage(val: number) {
  formFilter.page = val;
  fetchList();
}

function updatePageSize(newPagination: NewPagination) {
  formFilter.page = 1;
  formFilter.pageSize = newPagination.rowsPerPage;
}

watch(
  () => formFilter.pageSize,
  () => {
    fetchList();
  }
);

/**
 * function ต้นหาข้อมูลของ Option
 * @param val ค่าที่ต้องการฟิลเตอร์
 * @param update  อัพเดทค่า
 * @param refData ดาต้าที่ต้องการฟิลเตอร์
 */
function filterOption(val: any, update: Function) {
  update(() => {
    positionOp.value = positionMainOp.value.filter(
      (v: any) => v.name.indexOf(val) > -1
    );
  });
}

/** ดึงข้อมูลตำแหน่ง */
function getOptions() {
  showLoader();
  http.get(config.API.orgSalaryPosition).then((res) => {
    const dataOp = res.data.result;
    const uniqueNames = new Set();
    const filteredData = dataOp
      .filter((item: any) => {
        if (!uniqueNames.has(item.positionName)) {
          uniqueNames.add(item.positionName);
          return true;
        }
        return false;
      })
      .map((item: any) => ({
        id: item.positionName,
        name: item.positionName,
      }));

    positionMainOp.value = filteredData;
  });
}

function getRound() {
  showLoader();
  http
    .get(
      config.API.kpiPeriod +
        `?page=${formFilter.page}&pageSize=${formFilter.pageSize}&keyword=${formFilter.keyword}&year=${formFilter.year}`
    )
    .then((res) => {
      const data = res.data.result.data;
      roundOp.value = data.map((item: any) => ({
        id: item.id,
        name: statusTothai(item.durationKPI),
      }));
    })
    .finally(() => {
      hideLoader();
    });
}

function statusTothai(val: string) {
  switch (val) {
    case "SPECIAL":
      return "รอบพิเศษ";
    case "APR":
      return "รอบเมษายน";
    case "OCT":
      return "รอบตุลาคม";
    default:
      return "-";
  }
}

function setModel(val: string) {
  formFilter.position = val;
}

onMounted(async () => {
  await getOptions();
  await getRound();
  await fetchList();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    รายการตัวชี้วัดตามตำแหน่ง
  </div>
  <q-card flat bordered class="q-pa-md">
    <q-toolbar class="q-pa-none">
      <div class="row q-gutter-sm">
        <q-select
          dense
          :model-value="formFilter.position"
          label="ตำแหน่ง"
          outlined
          emit-value
          map-options
          fill-input
          hide-selected
          hide-bottom-space
          option-label="name"
          option-value="id"
          class="inputgreen"
          :options="positionOp"
          use-input
          @input-value="setModel"
          @filter="(inputValue:any,doneFn:Function) => filterOption(inputValue, doneFn) "
          @update:model-value="fetchList"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey"> ไม่มีข้อมูล </q-item-section>
            </q-item>
          </template>
          <template v-if="formFilter.position" v-slot:append>
            <q-icon
              name="cancel"
              @click.stop.prevent="
                formFilter.position = '';
                fetchList();
              "
              class="cursor-pointer"
            />
          </template>
        </q-select>

        <!-- <q-select
          dense
          outlined
          v-model="formFilter.position"
          :options="positionOp"
          label="ตำแหน่ง"
          option-label="name"
          option-value="id"
          emit-value
          map-options
        /> -->
        <datepicker
          style="width: 120px"
          menu-class-name="modalfix"
          v-model="formFilter.year"
          :locale="'th'"
          autoApply
          year-picker
          :enableTimePicker="false"
          @update:model-value="
            (formFilter.page = 1),
              (formFilter.round = ''),
              getRound(),
              fetchList()
          "
        >
          <template #year="{ year }">{{ year + 543 }}</template>
          <template #year-overlay-value="{ value }">{{
            parseInt(value + 543)
          }}</template>
          <template #trigger>
            <q-input
              dense
              lazy-rules
              outlined
              class="inputgreen"
              :model-value="
                formFilter.year === 0
                  ? 'ทั้งหมด'
                  : Number(formFilter.year) + 543
              "
              :label="`${'ปีงบประมาณ'}`"
            >
              <template v-slot:prepend>
                <q-icon
                  name="event"
                  class="cursor-pointer"
                  style="color: var(--q-primary)"
                >
                </q-icon>
              </template>
              <!-- <template v-if="formFilter.year" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop.prevent="
                    (formFilter.year = 0), (formFilter.page = 1), getRound(),fetchList()
                  "
                  class="cursor-pointer"
                />
              </template> -->
            </q-input>
          </template>
        </datepicker>

        <q-select
          dense
          outlined
          v-model="formFilter.round"
          :options="roundOp"
          label="รอบการประเมิน"
          option-label="name"
          option-value="id"
          emit-value
          map-options
          @update:model-value="fetchList"
          style="width: 160px"
        />
      </div>

      <q-btn
        flat
        round
        dense
        icon="add"
        color="primary"
        @click="onClickAddOrView()"
      >
        <q-tooltip>เพิ่ม</q-tooltip>
      </q-btn>

      <q-space />
      <div class="row q-gutter-sm">
        <q-input
          standout
          dense
          v-model="formFilter.keyword"
          ref="filterRef"
          outlined
          debounce="300"
          placeholder="ค้นหา"
        >
          <template v-slot:append>
            <q-icon v-if="formFilter.keyword == ''" name="search" />
            <q-icon
              v-if="formFilter.keyword !== ''"
              name="clear"
              class="cursor-pointer"
              @click="formFilter.keyword = ''"
            />
          </template>
        </q-input>

        <q-select
          v-model="visibleColumns"
          multiple
          outlined
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="columns"
          option-value="name"
          options-cover
          style="min-width: 150px"
        />
      </div>
    </q-toolbar>

    <div class="col-12">
      <d-table
        for="table"
        ref="table"
        :columns="columns"
        :rows="rows"
        row-key="subject"
        flat
        bordered
        dense
        class="custom-header-table"
        :visible-columns="visibleColumns"
        :rows-per-page-options="[10, 20, 50, 100]"
        @update:pagination="updatePageSize"
      >
        <template v-slot:pagination="scope">
          <q-pagination
            v-model="formFilter.page"
            active-color="primary"
            color="dark"
            :max="maxPage"
            :max-pages="5"
            size="sm"
            boundary-links
            direction-links
            @update:model-value="updatePage"
          ></q-pagination>
        </template>
        <template v-slot:header="props">
          <q-tr :props="props">
            <q-th v-for="col in props.cols" :key="col.name" :props="props">
              <span class="text-weight-medium">{{ col.label }}</span>
            </q-th>
            <q-th auto-width />
          </q-tr>
        </template>
        <template v-slot:body="props">
          <q-tr :props="props" class="cursor-pointer">
            <q-td v-for="col in props.cols" :key="col.name" :props="props">
              <div v-if="col.name === 'no'">
                {{
                  (formFilter.page - 1) * Number(pagination.rowsPerPage) +
                  props.rowIndex +
                  1
                }}
              </div>

              <div v-else class="table_ellipsis">
                {{ col.value ? col.value : "-" }}
              </div>
            </q-td>
            <q-td>
              <q-btn
                flat
                round
                icon="edit"
                color="edit"
                @click.stop.pervent="onClickAddOrView(true, props.row.id)"
              >
                <q-tooltip>แก้ไข </q-tooltip>
              </q-btn>
              <q-btn
                flat
                round
                icon="delete"
                color="red"
                @click.stop.pervent="onClickDelete(props.row.id)"
              >
                <q-tooltip>ลบข้อมูล </q-tooltip>
              </q-btn>
            </q-td>
          </q-tr>
        </template>
      </d-table>
    </div>
  </q-card>
</template>

<style scoped></style>
